class AppConfig < BasicObject
  # Alternative:
  #   Do not inherit from BasicObject and
  #   do this instead:
  #
  # instance_methods.each do |m|
  #   undef_method m unless m =~ /^__|object_id/
  # end

  def initialize
    @data = {}
  end

  def method_missing(name, *args)
    attribute = name.to_s

    if attribute =~ /=$/
      @data[attribute.chop] = args.first
    elsif attribute =~ /\?$/
      @data.has_key? attribute.chop
    else
      @data[attribute]
    end
  end
end

c = AppConfig.new
c.foo = 42
puts c.foo
puts c.foo?
puts c.bar?
